/*******************************************************************************
 * Copyright (c) 2016 Oracle and/or its affiliates. All rights reserved.
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v1.0 and Eclipse Distribution License v. 1.0
 * which accompanies this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 * Roman Grigoriadi
 ******************************************************************************/

package org.eclipse.yasson.adapters.model;

import javax.json.bind.adapter.JsonbAdapter;

/**
 * @author Roman Grigoriadi
 */
public abstract class BoxToCrateCompatibleGenericsAdapter<T> implements JsonbAdapter<GenericBox<T>,GenericCrate<T>> {

    @Override
    public GenericCrate<T> adaptToJson(GenericBox<T> tGenericBox) {
        GenericCrate<T> genericCrate = new GenericCrate<>();
        genericCrate.setCrateStrField(tGenericBox.getStrField());
        genericCrate.setT(tGenericBox.getX());
        return genericCrate;
    }

    @Override
    public GenericBox<T> adaptFromJson(GenericCrate<T> tGenericCrate) {
        GenericBox<T> genericBox = new GenericBox<>();
        genericBox.setStrField(tGenericCrate.getCrateStrField());
        genericBox.setX(tGenericCrate.getT());
        return genericBox;
    }
}
